Unit DE84R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE84RJ_p, AME2R_p, DE04RQ_p, DE00RS_p, UTDE20_p;

procedure DE84R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var E4 :Array of Real; var R :Array of Real;
                var R0 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
implementation

procedure DE84R(F :Proc_F_DE; M :Integer; var JSTART :Integer;
                HMIN :Real; EPS :Real; P :Real; var YX :Array of Real;
                var X :Real; var H :Real; var BUL :Boolean;
                var XP :Real; var YP :Array of Real;
                var A :Array of Real; var E1 :Array of Real;
                var E2 :Array of Real; var E3 :Array of Real;
                var E4 :Array of Real; var R :Array of Real;
                var R0 :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var YD :Array of Real; var IERR :Integer);
var
I,J :Integer;
C1,EPS1,EPSJ :Real;
BULD,BULEX,BULHM :Boolean;
const
EPS0 :Real = 1.0E-5;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190;
begin
IERR  := 0;
EPS1  := EPS/32.;
EPSJ  := EPS;
if ( EPS  < EPS0 ) 
 then goto _10;
EPSJ  := EPS0;
_10:
BULD  := True;
BULHM  := False;
BULEX  := False;
if ( JSTART ) < 0
 then goto _60
 else if ( JSTART ) > 0
       then goto _20
       else goto _80;
_20:
if ( JSTART  = 1 ) 
 then goto _110;
if ( JSTART  = 2 ) 
 then goto _30;
goto _90;
_30:
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E1[(I-1)+(J-1)*M] := E2[(I-1)+(J-1)*M];
_40:
   end;
_50:
 end;
goto _100;
_60:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_70:
 end;
X  := XP;
_80:
DE84RJ(F,X,YX,A,M,EPSJ,R1,R2);
_90:
C1  := H/4.;
AME2R(A,C1,M,E1,R,E3,E4);
if ( BULEX ) 
 then goto _110;
_100:
DE04RQ(M,E1,E2);
_110:
C1  := H/2.;
DE00RS(F,M,X,YX,H,A,E2,YD,R1,R2,R3);
DE00RS(F,M,X,YX,C1,A,E1,R0,R1,R2,R3);
DE00RS(F,M,X + C1,R0,C1,A,E1,R,R1,R2,R3);
for I:=1 to M do
 begin
  R1[I-1] := (R[I-1] - YD[I-1])/15.;
  C1  := Abs(R1[I-1]);
  if ( Abs(R[I-1])  >= P ) 
   then C1  := C1/Abs(R[I-1]);
  if ( C1  > EPS1 ) 
   then BULD  := False;
  if ( C1  >= EPS ) 
   then goto _150;
_120:
 end;
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_130:
 end;
XP  := X;
for I:=1 to M do
 begin
  YX[I-1] := R[I-1];
_140:
 end;
X  := X + H;
if ( BULD ) 
 then H  := H*2.;
goto _190;
_150:
if ( BULHM ) 
 then goto _180;
H  := H/2.;
BUL  := False;
BULEX  := True;
for J:=1 to M do
 begin
  for I:=1 to M do
   begin
    E2[(I-1)+(J-1)*M] := E1[(I-1)+(J-1)*M];
_160:
   end;
_170:
 end;
if ( Abs(H)  > Abs(HMIN) ) 
 then goto _90;
H  := Sign(HMIN,H);
BULHM  := True;
BULEX  := False;
goto _90;
_180:
IERR  := 65;
UTDE20(IERR,84);
_190:
JSTART  := 1;
if ( BULD ) 
 then JSTART  := 2;
end;

end.
